문제
given an array of integers return indices of the two numbers such that they add up to a specific target. You may assume that each input would hava exactly one solution, and you may not use the same element twice
Example
nums = [2,7,11,14] , target = 9,
answer : [0,1]
Because nums[0] + nums[1] = 2 + 7 = 9
풀이
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
public class TwoSum {
static int[] nums = { 2, 8, 11, 21 };
static int target = 10;
public static void main(String[] args) {
Map<Integer, Integer> map = new HashMap<>();
int[] result = new int[2];
for (int i = 0; i < nums.length; i++) {
if (map.containsKey(nums[i])) {
result[0] = map.get(nums[i]);
result[1] = i;
} else {
map.put(target - nums[i], i);
}
}
System.out.println(Arrays.toString(result));
}
}
-두 수의 합이 10이되는 두 개의 배열 원소를 구하는 문제이다.
- (target - answer1) = (answer2) 가 되어야한다. 따라서 map에 answer2를 put 하고, 배열 index를 돌면서 그 원소가 나오는 인덱스를 구한다.
'Algorithm by java' 카테고리의 다른 글
[알고리즘] merge-intervals (java 풀이) (0) | 2020.06.09 |
---|---|
[알고리즘] Daily temperatures (java 풀이) (0) | 2020.06.09 |
[알고리즘] MeetingRoom 문제 [백준1931 회의실배정 java] (0) | 2020.06.08 |
프로그래머스 stack/queue (0) | 2020.02.26 |
백준 11047 동전0 java (0) | 2020.02.07 |